<template>
  <div>
    <!--begin::Dashboard-->
    <div class="row mb-3">
      <div class="col-xxl-2 mb-2">
        <div class="card" style="height: 7em;">
          <div class="card-body" style="padding: 0.8em; display: flex; align-items: center;">
            <div class="d-flex align-items-center">
              <div>
                <i class="fas fa-user-circle fa-3x text-secondary"></i>
              </div>
              <div class="text-center ml-5">
                <div>
                  Jumlah Proyek
                </div>
                <div>
                  <p class="mb-0" style="fontSize: 2rem; fontWeight: bold;">{{this.currentCounterProject}}</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      
      <div class="col-xxl-2 mb-2">
        <div class="card" style="height: 7em;">
          <div class="card-body" style="padding: 0.8em; display: flex; align-items: center;">
            <div class="d-flex align-items-center">
              <div>
                <i class="fas fa-book fa-3x text-secondary"></i>
              </div>
              <div class="text-center ml-5">
                <div>
                  DMP Released
                </div>
                <div>
                  <p class="mb-0" style="fontSize: 2rem; fontWeight: bold;">{{this.currentCounterDMP}}</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-xxl-2 mb-2">
        <div class="card" style="height: 7em;">
          <div class="card-body" style="padding: 0.8em; display: flex; align-items: center;">
            <div class="d-flex align-items-center">
              <div>
                <i class="fas fa-sticky-note fa-3x"></i>
              </div>
              <div class="text-center ml-5">
                <div>
                  Open Item MoM
                </div>
                <div>
                  <p class="mb-0" style="fontSize: 2rem; fontWeight: bold;">{{this.currentCounterMOM}}</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-xxl-2 mb-2">
        <div class="card" style="height: 7em;">
          <div class="card-body" style="padding: 0.8em; display: flex; align-items: center;">
            <div class="d-flex align-items-center">
              <div>
                <i class="fas fa-box fa-3x text-secondary"></i>
              </div>
              <div class="text-center ml-5">
                <div>
                  Return status
                </div>
                <div>
                  <p class="mb-0" style="fontSize: 2rem; fontWeight: bold;">100</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-xxl-2 mb-2">
        <div class="card" style="height: 7em;">
          <div class="card-body" style="padding: 0.8em; display: flex; align-items: center;">
            <div class="d-flex align-items-center">
              <div>
                <i class="fas fa-cogs fa-3x text-secondary"></i>
              </div>
              <div class="text-center ml-5">
                <div>
                  Change Management
                </div>
                <div>
                  <p class="mb-0" style="fontSize: 2rem; fontWeight: bold;">{{this.currentCounterCR}}</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-xxl-2 mb-2">
        <div class="card" style="height: 7em;">
          <div class="card-body" style="padding: 0.8em; display: flex; align-items: center;">
            <div class="d-flex align-items-center">
              <div>
                <i class="fas fa-arrow-circle-up fa-3x text-secondary"></i>
              </div>
              <div class="text-center ml-5">
                <div>
                  Upload server
                </div>
                <div>
                  <p class="mb-0" style="fontSize: 2rem; fontWeight: bold;">100</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-xxl-2 mb-2">
        <div class="card" style="height: 7em;">
          <div class="card-body" style="padding: 0.8em; display: flex; align-items: center;">
            <div class="d-flex align-items-center">
              <div>
                <i class="fas fa-calendar-alt fa-3x text-secondary"></i>
              </div>
              <div class="text-center ml-5">
                <div>
                  Plan date
                </div>
                <div>
                  <p class="mb-0" style="fontSize: 2rem; fontWeight: bold;">{{ this.currentCounterPlan }}</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-xxl-2 mb-2">
        <div class="card" style="height: 7em;">
          <div class="card-body" style="padding: 0.8em; display: flex; align-items: center;">
            <div class="d-flex align-items-center">
              <div>
                <i class="fas fa-clipboard fa-3x text-secondary"></i>
              </div>
              <div class="text-center ml-5">
                <div>
                  Design Upload
                </div>
                <div>
                  <p class="mb-0" style="fontSize: 2rem; fontWeight: bold;">100</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- search column -->

    <div class="row mb-3">
      <div class="col-12">
        <div class="card">
          <div class="card-body">
            <b-row class="my-1 d-flex align-items-center">
              <b-col sm="3">
                <label>Kode Proyek :</label>
              </b-col>
              <b-col sm="9">
                <b-form-select :options="formattedProjectOptions" size="sm" class="mt-3"></b-form-select>
              </b-col>
            </b-row>
            <div class="row">
              <div class="col-12">
                <div class="text-right">
                  <button class="btn btn-primary">Tampilkan</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- end search column -->


    <!-- horizontal chart column -->
    
    <div class="row mb-3">
      <div class="col-12 col-xl-6 col-lg-6 col-md-6 col-sm-12">
        <div class="card">
          <div class="card-body">
            <ChartBar />
          </div>
        </div>
      </div>
      <div class="col-12 col-xl-6 col-lg-6 col-md-6 col-sm-12">
        <div class="card">
          <div class="card-body">
            <ChartBar />
          </div>
        </div>
      </div>
    </div>
    
    <!-- end horizontal chart column -->


    <!-- table target overview -->

    <div class="row mb-3">
      <div class="col-12">
        <div class="card">
          <div class="card-body">
            <div class="text-center">
              <h5>Target Overview</h5>
            </div>
            <div class="table-responsive">
              <table class="table table-stripped table-bordered">
                <thead>
                  <tr>
                    <th>Scope</th>
                    <th>No target</th>
                    <th>Remain</th>
                    <th>Next mo</th>
                    <th>Delay</th>
                    <th>Urgent</th>
                  </tr>
                </thead>
                <template
                  v-for="(item, i) in tableOverview"
                >
                  <tbody v-bind:key="i">
                    <tr>
                      <td>{{ item.scope }}</td>
                      <td>{{ item.no_target }}</td>
                      <td>{{ item.remain }}</td>
                      <td>{{ item.next_mo }}</td>
                      <td>{{ item.delay }}</td>
                      <td>{{ item.urgent }}</td>
                    </tr>
                  </tbody>
                </template>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- end table target overview -->


    <!-- vertical chart bar -->
    
    <div class="row mb-3">
      <div class="col-12 col-xl-6 col-lg-6 col-md-6 col-sm-12">
        <div class="card">
          <div class="card-body">
            <ChartVertical />
          </div>
        </div>
      </div>
      <div class="col-12 col-xl-6 col-lg-6 col-md-6 col-sm-12">
        <div class="card">
          <div class="card-body">
            <ChartVertical />
          </div>
        </div>
      </div>
    </div>
    
    <!-- end vertical chart bar -->


    <!-- last chart -->

    <div class="row mb-3">
      <div class="col-12 col-xl-8 col-lg-8 col-md-8 col-sm-12">
        <div class="card" style="max-height: 32em;">
          <div class="card-body">
            <ChartLine />
          </div>
        </div>
      </div>
      <div class="col-12 col-xl-4 col-lg-4 col-md-4 col-sm-12">
        <div class="card" style="max-height: 32em; height: 32em;">
          <div class="card-body">
            <!-- <div class="table-reponsive">
              <table class="table table-head-custom table-vertical-center table-head-bg table-borderless">
                <thead>
                  <tr>
                    <th>Plan date</th>
                    <th>Closed</th>
                    <th>Target</th>
                  </tr>
                </thead>
                <template
                  v-for="(item, i) in lastTable"
                >
                  <tbody v-bind:key="i">
                    <tr>
                      <td>{{ item.plan_date }}</td>
                      <td>{{ item.closed }}</td>
                      <td>{{ item.target }}</td>
                    </tr>
                  </tbody>
                </template>
              </table>
            </div> -->
            <div>
              <b-table sticky-header :items="lastTable" head-variant="dark"></b-table>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- end last chart -->

    <!-- <div class="row">
      <div class="col-xxl-4">
        <MixedWidget1></MixedWidget1>
      </div>
      <div class="col-xxl-4">
        <ListWidget9></ListWidget9>
      </div>
      <div class="col-xxl-4">
        <StatsWidget7></StatsWidget7>
        <StatsWidget12></StatsWidget12>
      </div>

      <div class="col-xxl-4 order-1 order-xxl-1">
        <ListWidget1></ListWidget1>
      </div>
      <div class="col-xxl-8 order-2 order-xxl-1">
        <AdvancedTableWidget2></AdvancedTableWidget2>
      </div>

      <div class="col-xxl-4 order-1 order-xxl-2">
        <ListWidget3></ListWidget3>
      </div>
      <div class="col-xxl-4 order-1 order-xxl-2">
        <ListWidget4></ListWidget4>
      </div>
      <div class="col-lg-12 col-xxl-4 order-1 order-xxl-2">
        <ListWidget8></ListWidget8>
      </div>

      <div class="col-xxl-4 order-1 order-xxl-2">
        <StatsWidget13></StatsWidget13>
      </div>
      <div class="col-xxl-8 order-1 order-xxl-2">
        <AdvancedTableWidget3></AdvancedTableWidget3>
      </div>
    </div> -->
    <!--end::Dashboard-->
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
// import AdvancedTableWidget2 from "@/view/content/widgets/advance-table/Widget2.vue";
// import AdvancedTableWidget3 from "@/view/content/widgets/advance-table/Widget3.vue";
// import MixedWidget1 from "@/view/content/widgets/mixed/Widget1.vue";
// import ListWidget1 from "@/view/content/widgets/list/Widget1.vue";
// import ListWidget3 from "@/view/content/widgets/list/Widget3.vue";
// import ListWidget4 from "@/view/content/widgets/list/Widget4.vue";
// import ListWidget8 from "@/view/content/widgets/list/Widget8.vue";
// import ListWidget9 from "@/view/content/widgets/list/Widget9.vue";
// import StatsWidget7 from "@/view/content/widgets/stats/Widget7.vue";
// import StatsWidget12 from "@/view/content/widgets/stats/Widget12.vue";
// import StatsWidget13 from "@/view/content/widgets/stats/Widget13.vue";
import ChartBar from "@/view/content/widgets/dashboard/ChartBar.vue";
import ChartVertical from "@/view/content/widgets/dashboard/ChartBarVertical.vue";
import ChartLine from "@/view/content/widgets/dashboard/ChartLine.vue";
import { GET_COUNTER_PROJECT, GET_COUNTER_DMP, GET_COUNTER_MOM, GET_COUNTER_PLAN, GET_COUNTER_CR } from "@/core/services/store/dashboard-main.module"; 
import { mapGetters } from "vuex";
import { arrayMoreThanOne } from "@/core/helper/array-validation.helper";
import { GET_PROJECT_DETAIL } from "@/core/services/store/project.module";


export default {
  name: "dashboard",
  data() {
    return {
      options: [
          { value: null, text: 'Please select an option' },
          { value: 'a', text: 'This is First option' },
          { value: 'b', text: 'Selected Option' },
          { value: { C: '3PO' }, text: 'This is an option with object value' },
          { value: 'd', text: 'This one is disabled', disabled: true }
      ],
      tableOverview: [
        {
          scope: "Logic",
          no_target: "0",
          remain: "1",
          next_mo: "0",
          delay: "4",
          urgent: "3"
        },
        {
          scope: "HMI",
          no_target: "2",
          remain: "1",
          next_mo: "4",
          delay: "0",
          urgent: "1"
        }
      ],
      lastTable: [
        {
          plan_date: "10-08-2021",
          closed: "1",
          target: "6"
        },
        {
          plan_date: "15-08-2021",
          closed: "1",
          target: "7"
        },
        {
          plan_date: "20-08-2021",
          closed: "1",
          target: "7"
        },
        {
          plan_date: "10-08-2021",
          closed: "1",
          target: "6"
        },
        {
          plan_date: "15-08-2021",
          closed: "1",
          target: "7"
        },
        {
          plan_date: "20-08-2021",
          closed: "1",
          target: "7"
        },
        {
          plan_date: "10-08-2021",
          closed: "1",
          target: "6"
        },
        {
          plan_date: "15-08-2021",
          closed: "1",
          target: "7"
        },
        {
          plan_date: "20-08-2021",
          closed: "1",
          target: "7"
        }
      ]
    }
  },
  components: {
    // AdvancedTableWidget2,
    // AdvancedTableWidget3,
    // MixedWidget1,
    // ListWidget1,
    // ListWidget3,
    // ListWidget4,
    // ListWidget8,
    // ListWidget9,
    // StatsWidget7,
    // StatsWidget12,
    // StatsWidget13,
    ChartBar,
    ChartVertical,
    ChartLine
  },
  async created() {

    await this.$store.dispatch(SET_BREADCRUMB, [{ title: "Dashboard" }]);
    await this.$store.dispatch(GET_COUNTER_PROJECT); 
    await this.$store.dispatch(GET_COUNTER_DMP);
    await this.$store.dispatch(GET_COUNTER_MOM);
    await this.$store.dispatch(GET_COUNTER_CR);
    await this.$store.dispatch(GET_COUNTER_PLAN);
    await this.$store.dispatch(GET_PROJECT_DETAIL, "design");




    console.log(' proyek',this.currentProjectDetails)

  },
  computed: { 
    ...mapGetters(["currentProjectDetails","currentCounterProject","currentCounterDMP","currentCounterMOM","currentCounterCR","currentCounterPlan"]), 
    formattedProjectOptions() { 
      let projects = []; 
      if(arrayMoreThanOne(this.currentProjectDetails)) { 
        projects = this.currentProjectDetails.map(project => {
          return { value: project.code, text: project.code + '-' + project.nickname}; 
        }); 
      } 
      
      return [{ value: null, text: "Pilih Project" }, ...projects]; },

  },

  methods: {
    getProjects() { 
     this.$store.dispatch(GET_PROJECT_DETAIL, "design");
 
    },

    setActiveTab1(event) {
      this.tabIndex = this.setActiveTab(event);
    },
    setActiveTab2(event) {
      this.tabIndex2 = this.setActiveTab(event);
    },
    /**
     * Set current active on click
     * @param event
     */
    setActiveTab(event) {
      // get all tab links
      const tab = event.target.closest('[role="tablist"]');
      const links = tab.querySelectorAll(".nav-link");
      // remove active tab links
      for (let i = 0; i < links.length; i++) {
        links[i].classList.remove("active");
      }

      // set current active tab
      event.target.classList.add("active");

      // set clicked tab index to bootstrap tab
      return parseInt(event.target.getAttribute("data-tab"));
    }
  }
};
</script>

